//////////////////////////////////////////////////////////////
//
//  Function that gives musical options for an image
//   and creates the beginning of the IMS file
//
///////////////////////////////////////////////////////////////
int * ImageSpecs(void)
{
  int i, nRet = 0, ctr = 0, rctr = 0, lctr = 0, currMenu = 0, currSpec = 0, numOpts = 0; 
  extern int right,left,select,back;
  
  int header[6];  
  char ** temp;
  
  char str[5];
  
   
  char * specs[6] = {"    Select a Clef   ",
                     "    Select a Key    ",
                     " Time Signature Top ",
                     "  Time Sig. Bottom  ",
                     "  MIDI Instrument   ",
                     "   Select a Tempo   "};
                     
  char * clefSub[2] = {"      Bass Clef     ",
                       "     Treble Clef    "};
                        
  char * keySub[15] = {" C Major (no sharps)",
                       " F Major - (1 flat) ",
                       "Bb Major - (2 flats)",
                       "Eb Major - (3 flats)",
                       "Ab Major - (4 flats)",
                       "Db Major - (5 flats)",
                       "Gb Major - (6 flats)",
                       "Cb Major - (7 flats)",
                       "G Major - (1 sharp) ",
                       "D Major - (2 sharps)",
                       "A Major - (3 sharps)",
                       "E Major - (4 sharps)",
                       "B Major - (5 sharps)",
                       "F# Major  (6 sharps)",
                       "C# major  (7 sharps)"};
                       
    char * instSub[128] = 
{
"   Acoustic Piano   ","    Bright Piano    ","Electric Grand Piano","  Honky-tonk Piano  ","  Electric Piano 1  ",
"  Electric Piano 2  ","    Harpsichord     ","        Clavi       ","       Celesta      ","    Glockenspiel    ",
"     Music Box      ","    Vibraphone      ","      Marimba       ","     Xylophone      ","    Tubular Bell    ",
"      Dulcimer      ","   Drawbar Organ    ","  Percussive Organ  ","     Rock Organ     ","    Church organ    ",
"     Reed organ     ","      Accordion     ","      Harmonica     ","   Tango Accordion  ","Acous Guitar (nylon)",
"Acous Guitar (steel)","Elec. Guitar (jazz) ","Elec. Guitar (clean)","Elec. Guitar (muted)","  Overdriven Guitar ",
"  Distortion Guitar ","  Guitar harmonics  ","   Acoustic Bass    ","Elec. Bass (finger) "," Elec. Bass (pick)  ",
"    Fretless Bass   ","     Slap Bass 1    ","     Slap Bass 2    ","    Synth Bass 1    ","    Synth Bass 2    ",
"       Violin       ","        Viola       ","        Cello       ","     Double bass    ","   Tremolo Strings  ",
"  Pizzicato Strings ","   Orchestral Harp  ","      Timpani       ","  String Ensemble 1 ","  String Ensemble 2 ",
"   Synth Strings 1  ","   Synth Strings 2  ","     Voice Aahs     ","     Voice Oohs     ","    Synth Voice     ",
"   Orchestra Hit    ","      Trumpet       ","      Trombone      ","        Tuba        ","   Muted Trumpet    ",
"    French horn     ","   Brass Section    ","   Synth Brass 1    ","   Synth Brass 2    ","    Soprano Sax     ",
"      Alto Sax      ","     Tenor Sax      ","    Baritone Sax    ","        Oboe        ","    English Horn    ",
"      Bassoon       ","      Clarinet      ","       Piccolo      ","       Flute        ","      Recorder      ",
"     Pan Flute      ","    Blown Bottle    ","      Shakuhachi    ","      Whistle       ","       Ocarina      ",
"  Lead 1 (square)   ","  Lead 2 (sawtooth) ","  Lead 3 (calliope) ","   Lead 4 (chiff)   ","  Lead 5 (charang)  ",
"   Lead 6 (voice)   ","   Lead 7 (fifths)  ","Lead 8 (bass + lead)","   Pad 1 (new age)  ","    Pad 2 (warm)    ",
" Pad 3 (polysynth)  ","   Pad 4 (choir)    ","   Pad 5 (bowed)    ","  Pad 6 (metallic)  ","    Pad 7 (halo)    ",
"   Pad 8 (sweep)    ","     FX 1 (rain)    "," FX 2 (soundtrack)  ","   FX 3 (crystal)   ","  FX 4 (atmosphere) ",
"  FX 5 (brightness) ","   FX 6 (goblins)   ","   FX 7 (echoes)    ","   FX 8 (sci-fi)    ","        Sitar       ",
"       Banjo        ","      Shamisen      ","        Koto        ","       Kalimba      ","      Bagpipe       ",
"       Fiddle       ","       Shanai       ","    Tinkle Bell     ","     Agogo Bells    ","    Steel Drums     ",
"     Woodblock      ","     Taiko Drum     ","    Melodic Tom     ","     Synth Drum     ","   Reverse Cymbal   ",
"  Guitar Fret Noise ","    Breath Noise    ","      Seashore      ","     Bird Tweet     ","   Telephone Ring   ",
"     Helicopter     ","      Applause      ","       Gunshot      "};              

  char * timeSubtop[3] = {"    4 notes/meas    ","    3 notes/meas    ","    2 notes/meas    "};
  char * timeSub[2] = {"  4 - quarter notes "," 8 - eighth notes  "};
  char ** currSub[5] = {clefSub, keySub,timeSubtop,timeSub,instSub};
  int SubNumOpts[5] = {1,14,2,1,127};                 
  temp = currSub[0];
  numOpts = 1;
  currMenu = 0;
  ImageTemplate();
  printLine2(specs[0]);
  printLine3(temp[currMenu]);
  
  while(1){ // Polls through the 4 user input options (right, left, select, back)
    
  if (left == 1){// Scrolls left if there are options to scroll
    lctr++;
    left=0;
      if (lctr == 2){
        lctr = 0;
        left = 0;
        
        if (currMenu == 0){
          currMenu = numOpts;
          i = sprintf(str, "%d", currMenu);
          if (currSpec == 5){
            outchar(0x110602);
            print("   ");
            outchar(0x110602);
            print(str);
          }
          else {
            printLine3(temp[currMenu]);
          }
        }
        else{
          currMenu--; 
          i = sprintf(str, "%d", currMenu);
          if (currSpec == 5){
            outchar(0x110602);
            print("   ");
            outchar(0x110602);
            print(str);
          }
          else {
            printLine3(temp[currMenu]);
          }
        }
      }  
  }
   
  else if (right == 1){ //scrolls right if there are options to scroll
    rctr++;
    right=0;
      if (rctr == 2){
        rctr = 0;
        right = 0;
        
        if (currMenu == numOpts){
          currMenu = 0;
          i = sprintf(str, "%d", currMenu);
          if (currSpec == 5){
            outchar(0x110602);
            print("   ");
            outchar(0x110602);
            print(str);
          }
          else {
            printLine3(temp[currMenu]);
          }
         
        }
        else{
          currMenu++;
          //printLine3(temp[currMenu]);
          i = sprintf(str, "%d", currMenu);
          if (currSpec == 5){
            outchar(0x110602);
            print("   ");
            outchar(0x110602);
            print(str);
          }
          else {
            printLine3(temp[currMenu]);
          }

        }    
      }
  }

  ///////////////////////////////////////////
  //
  //  Checks if there is a select button hit
  //
  ///////////////////////////////////////////
  
  else if (select == 1){ 
    select = 0;
    
    if (currSpec == 0){//Assigns values to header...byte 1 = tempo, byte 2 = key, byte 3 = tim sig top
      if (currMenu == 0){//                      byte 4 = time sig bot, byte 5 = tempo, byte 6 = clef
        header[5] = -1;
      }
      else if (currMenu == 1){
        header[5]  = 1;
      }
    }
    else if (currSpec == 1){
      if (currMenu > 0 && currMenu < 8){
        header[1] = -1 * currMenu;
      }
      else if (currMenu >= 8){
        header[1] = currMenu - 7;
      }
      else {
        header[1] = 0;
      }
    }
    else if (currSpec == 2){
      if (currMenu == 0){
        header[2] = 4;
      }
      else if (currMenu == 1){
        header[2] = 3;
      }
      else if (currMenu == 2){
        header[2] = 2;
      }
    }
    else if (currSpec == 3){
      if (currMenu == 0){
        header[3] = 4;
      }
      else if (currMenu == 1){
        header[3] = 8;
      }      
    }
    else if (currSpec == 4){
      header[4] = currMenu;
    }
    else if (currSpec == 5){
      header[0] = currMenu;
    }
    
    if (currSpec == 5){
        MainMenuTemplate();
        printMenu("creating IMS...select for new image");
       // for (i=0; i < 6;i++){
       //     printf("%d\n",header[i]);
       // }
        while (select == 0){
        }
        select = 0;
        return header;
    }
    currSpec++;
    printLine2(specs[currSpec]);
    
    if (currSpec == 5){
      select = 0;
      printLine3("          BPM       ");
      numOpts = 250;
      currMenu = 120;
      outchar(0x110602);
      print("120");
      for(i=0; i<65000; i++){
        i=i;
      }
      
    }
    else {
      select = 0;                  
      temp = currSub[currSpec];
      printLine3(currSub[currSpec][0]);
      numOpts = SubNumOpts[currSpec];
      currMenu = 0;
    }

  }
  
///////////////////////////////////////////
//
//  Checks if there is a back button hit
//
///////////////////////////////////////////

  else if (back == 1) {
    back = 0;
	if (currSpec == 0){
	  return NULL;    
    }
	else {
      currSpec--;
      printLine2(specs[currSpec]);
      temp = currSub[currSpec];
      printLine3(currSub[currSpec][0]);
      numOpts = SubNumOpts[currSpec];
      currMenu = 0;
	}
  }



} // End of Menu Polling loop.
  
  
}


/////////////////////////////////////////////////////
//
// Functions to print the top and bottom line
//   vary depending on where in the menu you are
//
//////////////////////////////////////////////////////

void MainMenuTemplate(void)
{
    int w;
  outchar(0x0ce1);
  print("   "); 
  print("More Options");
  print("   ");
  outchar(0xdf110003);
  print(" ");
  for(w=0; w<65000; w++){
    w=w;
  } 
  outchar(0xfa);
  print("Select");
  outchar(0xfc);
  for(w=0; w<65000; w++){
    w=w;
  }
}

void MenuTemplate(void)
{
    int w;
  outchar(0x0ce1);
  print("   "); 
  print("More Options");
  print("   ");
  outchar(0xdf110003);
  print(" ");
  outchar(0x20fa);
  print("Select");
  outchar(0xfc);
  print("    ");
  outchar(0xfa);
  print("Back");
  outchar(0xfc);
  for(w=0; w<65000; w++){
    w=w;
  }
}

void ImageTemplate(void)
{
    int w;
  outchar(0x0ce1);
  print("   "); 
  print("More Options");
  print("   ");
  outchar(0xdf110003);
  print(" ");
  outchar(0x20fa);
  print("Select");
  outchar(0xfc);
  print("  ");
  outchar(0xfa);
  print("Cancel");
  outchar(0xfc);
  for(w=0; w<65000; w++){
    w=w;
  }
}

void FileNameTemplate(void)
{
    int w;
  outchar(0x0ce1);
  print("   "); 
  print("Choose a file");
  print("  ");
  outchar(0xdf110003);
  print(" ");
  outchar(0x20fa);
  print("Select");
  outchar(0xfc);
  print("    ");
  outchar(0xfa);
  print("Back");
  outchar(0xfc);
  for(w=0; w<65000; w++){
    w=w;
  }
}

void LCDMenuTemplate(void)
{
  int w;
  outchar(0x0ce1);
  print("   "); 
  print("Change Value");
  print("   ");
  outchar(0xdf110003);
  print("             ");
  outchar(0xfa);
  print("Back");
  outchar(0xfc);
  for(w=0; w<65000; w++){
    w=w;
  }
}

//////////////////////////////////////////////////////
//
// Function for printing specific lines on the LCD
//
///////////////////////////////////////////////////////

void printMenu(char message[])
{
    outchar(0x110001);
    print("                                        ");
    outchar(0x110001); 
    print(message);
}

void printLine2(char message[])
{
    outchar(0x110001);
    print("                    ");
    outchar(0x110001); 
    print(message);
}

void printLine3(char message[])
{
    outchar(0x110002);
    print("                    ");
    outchar(0x110002); 
    print(message);
}
